package com.bdifn.hbase.hfile;

import java.io.ByteArrayInputStream;
import java.net.URI;
import java.nio.ByteBuffer;
import java.util.Arrays;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FSDataInputStream;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.hbase.util.Bytes;

import com.bdifn.hbase.hfile.proto.HFileProtos.FileTrailerProto;

public class ParseTrailler {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		Configuration config = new Configuration();

		// 我已经将文件拷到了f盘根目录
		String pathStr = "file:///f:/0a99d83b2b0a49c0adbc371d4bfe021e";
		Path path = new Path(pathStr);
		FileSystem fs = FileSystem.get(URI.create(pathStr), config);

		FSDataInputStream input = fs.open(path);

		long length = input.available();
		int trailerSize = 212;

		input.seek(length - trailerSize);
		byte[] trailerBytes = new byte[trailerSize];
		input.read(trailerBytes);
		
		ByteBuffer trailerBuf = ByteBuffer.wrap(trailerBytes);
		trailerBuf.position(trailerSize - 4);
		
		int version = trailerBuf.getInt();
		//3, 0, 0, 2
		//最后三位是majorVersion
		int majorVersion = version & 0x00ffffff;
		//高位是 minorVersion
		int minorVersion = version >>> 24;
		
		String magicCode = Bytes.toString(Arrays.copyOfRange(trailerBytes, 0, 8));

		// 除去头8个字节MagicCode ,除去尾4个字节version信息。咱就是这么暴力。
		FileTrailerProto hfileProtos = FileTrailerProto.PARSER
				.parseDelimitedFrom(new ByteArrayInputStream(trailerBytes, 8,
						trailerSize - 4));
		System.out.println(String.format("MagicCode:%s,majorVersion:%d,:minorVersion:%d",magicCode,majorVersion,minorVersion));
		System.out.println(hfileProtos);
	}

}
